uniform extern float4x4	worldViewProj;  // World * View * Projection transformation
uniform extern float3	cameraPosition;

// Vertex shader output structure
struct VSOutput
{
	float4 position:POSITION;
	float3 reflected:TEXCOORD0;
};

struct VSInput
{
	float4 position:POSITION;
	float3 normal:NORMAL;
};

VSOutput main(VSInput input)
{
	VSOutput output;
	
	float3 view = input.position.xyz - cameraPosition.xyz;
	output.reflected = reflect(view, input.normal);
	
	output.position = mul(input.position, worldViewProj);
	
	return output;
}